"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useRange;
var _react = require("react");
var _moment = _interopRequireDefault(require("moment"));
var _date = require("../utils/date");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function useRange(_ref) {
  let {
    startDate,
    endDate,
    numberOfMonths,
    firstMonthToRender
  } = _ref;
  return (0, _react.useMemo)(() => {
    let start;
    const lastMonth = (0, _moment.default)(firstMonthToRender).add(numberOfMonths, 'months').toDate();
    if (startDate && (0, _date.isValidDate)(new Date(startDate))) {
      start = (0, _moment.default)(startDate, 'YYYY-MM-DD').toDate();
      if (start > lastMonth) {
        start = undefined;
      }
    }
    let end = endDate && (0, _date.isValidDate)(new Date(endDate)) && endDate <= lastMonth ? (0, _moment.default)(endDate, 'YYYY-MM-DD').toDate() : undefined;
    return {
      start,
      end
    };
  }, [endDate, firstMonthToRender, numberOfMonths, startDate]);
}
//# sourceMappingURL=use-range.js.map